Robot Simulator of the Robotics Group for Self-Organization of Control: AbstractTrackSection Class Reference

# AbstractTrackSection Class Reference

Abstract class (interface) for obstacles. More...

`#include <abstracttracksection.h>`

Inherited by DegreeSegment, and StraightLine.

Collaboration diagram for AbstractTrackSection:
[legend]

List of all members.

## Public Member Functions
| AbstractTrackSection (const Position &p, const double angle)
| Constructor, segment is initialized with Position (0,0,0) and a rotation angle=0.
| AbstractTrackSection (const Matrix &pose)
| Constructor where you can set the pos-matrix by this constructor:
virtual | ~AbstractTrackSection ()
virtual void | create (dSpaceID space)=0
virtual void | destroy ()=0
virtual void | draw ()=0
virtual Matrix | getTransformedEndMatrix ()=0
| gives the position and rotation(angle) of the segment at the end of the segment so that a new segment could be placed there the result is a matrix
virtual bool | isInside (const Position &p)=0
| returns true if the real coordinates lay inside of the segment
virtual double | getSectionIdValue (const Position &p)=0
| returns a value between 0 and length that tells at which section you are on the segment.
virtual double | getWidthIdValue (const Position &p)=0
| returns a value between 0 and width that tells at which width you are on the segment, 0 means right and width means left.
virtual double | getLength ()=0
| returns the length of the segment, here it is the length of the arc formula is: radius * angle;
virtual double | getWidth ()=0
| returns the width of the segment,
virtual void | setWidth (double w)=0
| sets the width of the segment,
Matrix | getPoseMatrix ()
Position | transformToLocalCoord (const Position &p)
Position | transformToGlobalCoord (const Position &p)
Matrix | getInversePoseMatrix ()
## Protected Member Functions
void | setPoseMatrix (const Matrix &m)
Position | getPosition ()
| gives actual position of the obstacle

## Detailed Description

Abstract class (interface) for obstacles.

## Constructor & Destructor Documentation

AbstractTrackSection | ( | const Position & | p,
|  | const double | angle |
| ) |  |  | `[inline]`

Constructor, segment is initialized with Position (0,0,0) and a rotation angle=0.

Constructor where you can set the position and rotation by:

Parameters:

  | p | is the position of the segment
  | angle | is the rotation of the segment

AbstractTrackSection | ( | const Matrix & | pose | ) | `[inline]`

Constructor where you can set the pos-matrix by this constructor:

Parameters:

  | position | is the position AND rotation of the segment

virtual ~AbstractTrackSection | ( |  | ) | `[inline, virtual]`

## Member Function Documentation

virtual void create | ( | dSpaceID | space | ) | `[pure virtual]`

Implemented in DegreeSegment, and StraightLine.

virtual void destroy | ( |  | ) | `[pure virtual]`

Implemented in DegreeSegment, and StraightLine.

virtual void draw | ( |  | ) | `[pure virtual]`

Implemented in DegreeSegment, and StraightLine.

Matrix getInversePoseMatrix | ( |  | ) | `[inline]`

virtual double getLength | ( |  | ) | `[pure virtual]`

returns the length of the segment, here it is the length of the arc formula is: radius * angle;

Implemented in DegreeSegment, and StraightLine.

Matrix getPoseMatrix | ( |  | ) | `[inline]`

Position getPosition | ( |  | ) | `[inline, protected]`

gives actual position of the obstacle

virtual double getSectionIdValue | ( | const Position & | p | ) | `[pure virtual]`

returns a value between 0 and length that tells at which section you are on the segment.

returns -1 if no IdValue can be given

Implemented in DegreeSegment, and StraightLine.

virtual Matrix getTransformedEndMatrix | ( |  | ) | `[pure virtual]`

gives the position and rotation(angle) of the segment at the end of the segment so that a new segment could be placed there the result is a matrix

Implemented in DegreeSegment, and StraightLine.

virtual double getWidth | ( |  | ) | `[pure virtual]`

returns the width of the segment,

Implemented in DegreeSegment, and StraightLine.

virtual double getWidthIdValue | ( | const Position & | p | ) | `[pure virtual]`

returns a value between 0 and width that tells at which width you are on the segment, 0 means right and width means left.

returns -1 if no WidthValue can be given

Implemented in DegreeSegment, and StraightLine.

virtual bool isInside | ( | const Position & | p | ) | `[pure virtual]`

returns true if the real coordinates lay inside of the segment

Implemented in DegreeSegment, and StraightLine.

void setPoseMatrix | ( | const Matrix & | m | ) | `[inline, protected]`

virtual void setWidth | ( | double | w | ) | `[pure virtual]`

sets the width of the segment,

Implemented in DegreeSegment, and StraightLine.

Position transformToGlobalCoord | ( | const Position & | p | ) | `[inline]`

Position transformToLocalCoord | ( | const Position & | p | ) | `[inline]`

The documentation for this class was generated from the following file:

- abstracttracksection.h